#include "ByteVoxmapTestDeath.h"

START_DEATH

TEST(ByteVoxmap, New) {
  ByteVoxmap *_ = null;

  EXPECT_DEATH(byte_voxmap_new(&_, 0, 1, 1), "Width must be nonzero");
  byte_voxmap_delete(&_);

  EXPECT_DEATH(byte_voxmap_new(&_, 1, 0, 1), "Height must be nonzero");
  byte_voxmap_delete(&_);

  EXPECT_DEATH(byte_voxmap_new(&_, 1, 1, 0), "Depth must be nonzero");
  byte_voxmap_delete(&_);
}

TEST(ByteVoxmap, GetSet) {
  ByteVoxmap *_ = null;

  byte_voxmap_new(&_, 1, 1, 1);
  EXPECT_DEATH(
      byte_voxmap_get(_, 1, 0, 0),
      "i (1) must be less than width (1)");
  EXPECT_DEATH(
      byte_voxmap_get(_, 0, 1, 0),
      "j (1) must be less than height (1)");
  EXPECT_DEATH(
      byte_voxmap_get(_, 0, 0, 1),
      "k (1) must be less than depth (1)");
  EXPECT_DEATH(
      byte_voxmap_set(_, 1, 0, 0, 0xff),
      "i (1) must be less than width (1)");
  EXPECT_DEATH(
      byte_voxmap_set(_, 0, 1, 0, 0xff),
      "j (1) must be less than height (1)");
  EXPECT_DEATH(
      byte_voxmap_set(_, 0, 0, 1, 0xff),
      "k (1) must be less than depth (1)");
  byte_voxmap_delete(&_);
}

FINISH_DEATH
